/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.builders;

import fr.obeo.acceleo.gen.ui.AcceleoEcoreGenUiPlugin;

/**
 * Markers used by the generator.
 * 
 * @author www.obeo.fr
 * 
 */
public interface IAcceleoGenMarker {

	/**
	 * This is a problem marker type for the generators. It can be used to
	 * recognize those markers in the workspace that flag problems detected by
	 * the generators during compilation.
	 */
	public static final String PROBLEM_MARKER = AcceleoEcoreGenUiPlugin.getDefault().getID() + ".problem";

}
