/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Reception;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.SendAction;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Signal;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ClassifierImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Signal</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.SignalImpl#getReception <em>Reception</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.SignalImpl#getContext <em>Context</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.SignalImpl#getSendAction <em>Send Action</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.SignalImpl#getOccurrence <em>Occurrence</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class SignalImpl extends ClassifierImpl implements Signal {
	/**
	 * The cached value of the '{@link #getReception() <em>Reception</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getReception()
	 * @generated
	 * @ordered
	 */
	protected EList reception = null;

	/**
	 * The cached value of the '{@link #getContext() <em>Context</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getContext()
	 * @generated
	 * @ordered
	 */
	protected EList context = null;

	/**
	 * The cached value of the '{@link #getSendAction() <em>Send Action</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSendAction()
	 * @generated
	 * @ordered
	 */
	protected EList sendAction = null;

	/**
	 * The cached value of the '{@link #getOccurrence() <em>Occurrence</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOccurrence()
	 * @generated
	 * @ordered
	 */
	protected EList occurrence = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SignalImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getSignal();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getReception() {
		if (reception == null) {
			reception = new EObjectWithInverseResolvingEList(Reception.class, this, Common_behaviorPackage.SIGNAL__RECEPTION, Common_behaviorPackage.RECEPTION__SIGNAL);
		}
		return reception;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getContext() {
		if (context == null) {
			context = new EObjectWithInverseResolvingEList.ManyInverse(BehavioralFeature.class, this, Common_behaviorPackage.SIGNAL__CONTEXT, CorePackage.BEHAVIORAL_FEATURE__RAISED_SIGNAL);
		}
		return context;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSendAction() {
		if (sendAction == null) {
			sendAction = new EObjectWithInverseResolvingEList(SendAction.class, this, Common_behaviorPackage.SIGNAL__SEND_ACTION, Common_behaviorPackage.SEND_ACTION__SIGNAL);
		}
		return sendAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getOccurrence() {
		if (occurrence == null) {
			occurrence = new EObjectWithInverseResolvingEList(SignalEvent.class, this, Common_behaviorPackage.SIGNAL__OCCURRENCE, State_machinesPackage.SIGNAL_EVENT__SIGNAL);
		}
		return occurrence;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.SIGNAL__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.SIGNAL__NAMESPACE, msgs);
			case Common_behaviorPackage.SIGNAL__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.SIGNAL__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__FEATURE:
				return ((InternalEList) getFeature()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TYPED_FEATURE:
				return ((InternalEList) getTypedFeature()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TYPED_PARAMETER:
				return ((InternalEList) getTypedParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__ASSOCIATION:
				return ((InternalEList) getAssociation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SPECIFIED_END:
				return ((InternalEList) getSpecifiedEnd()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__INSTANCE:
				return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__RECEPTION:
				return ((InternalEList) getReception()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CONTEXT:
				return ((InternalEList) getContext()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SEND_ACTION:
				return ((InternalEList) getSendAction()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__OCCURRENCE:
				return ((InternalEList) getOccurrence()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.SIGNAL__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.SIGNAL__NAMESPACE, msgs);
			case Common_behaviorPackage.SIGNAL__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.SIGNAL__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__FEATURE:
				return ((InternalEList) getFeature()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TYPED_FEATURE:
				return ((InternalEList) getTypedFeature()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__TYPED_PARAMETER:
				return ((InternalEList) getTypedParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__ASSOCIATION:
				return ((InternalEList) getAssociation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SPECIFIED_END:
				return ((InternalEList) getSpecifiedEnd()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__INSTANCE:
				return ((InternalEList) getInstance()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__RECEPTION:
				return ((InternalEList) getReception()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__CONTEXT:
				return ((InternalEList) getContext()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__SEND_ACTION:
				return ((InternalEList) getSendAction()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.SIGNAL__OCCURRENCE:
				return ((InternalEList) getOccurrence()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.SIGNAL__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.SIGNAL__NAME:
			return getName();
		case Common_behaviorPackage.SIGNAL__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.SIGNAL__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.SIGNAL__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.SIGNAL__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.SIGNAL__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.SIGNAL__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.SIGNAL__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.SIGNAL__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.SIGNAL__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.SIGNAL__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case Common_behaviorPackage.SIGNAL__COMMENT:
			return getComment();
		case Common_behaviorPackage.SIGNAL__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.SIGNAL__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case Common_behaviorPackage.SIGNAL__STEREOTYPE:
			return getStereotype();
		case Common_behaviorPackage.SIGNAL__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.SIGNAL__REFERENCE_TAG:
			return getReferenceTag();
		case Common_behaviorPackage.SIGNAL__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case Common_behaviorPackage.SIGNAL__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.SIGNAL__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.SIGNAL__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case Common_behaviorPackage.SIGNAL__PARTITION:
			return getPartition();
		case Common_behaviorPackage.SIGNAL__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.SIGNAL__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.SIGNAL__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.SIGNAL__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.SIGNAL__GENERALIZATION:
			return getGeneralization();
		case Common_behaviorPackage.SIGNAL__SPECIALIZATION:
			return getSpecialization();
		case Common_behaviorPackage.SIGNAL__OWNED_ELEMENT:
			return getOwnedElement();
		case Common_behaviorPackage.SIGNAL__FEATURE:
			return getFeature();
		case Common_behaviorPackage.SIGNAL__TYPED_FEATURE:
			return getTypedFeature();
		case Common_behaviorPackage.SIGNAL__TYPED_PARAMETER:
			return getTypedParameter();
		case Common_behaviorPackage.SIGNAL__ASSOCIATION:
			return getAssociation();
		case Common_behaviorPackage.SIGNAL__SPECIFIED_END:
			return getSpecifiedEnd();
		case Common_behaviorPackage.SIGNAL__POWERTYPE_RANGE:
			return getPowertypeRange();
		case Common_behaviorPackage.SIGNAL__INSTANCE:
			return getInstance();
		case Common_behaviorPackage.SIGNAL__CREATE_ACTION:
			return getCreateAction();
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case Common_behaviorPackage.SIGNAL__OBJECT_FLOW_STATE:
			return getObjectFlowState();
		case Common_behaviorPackage.SIGNAL__RECEPTION:
			return getReception();
		case Common_behaviorPackage.SIGNAL__CONTEXT:
			return getContext();
		case Common_behaviorPackage.SIGNAL__SEND_ACTION:
			return getSendAction();
		case Common_behaviorPackage.SIGNAL__OCCURRENCE:
			return getOccurrence();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.SIGNAL__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.SIGNAL__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.SIGNAL__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.SIGNAL__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.SIGNAL__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__FEATURE:
			getFeature().clear();
			getFeature().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__TYPED_FEATURE:
			getTypedFeature().clear();
			getTypedFeature().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__TYPED_PARAMETER:
			getTypedParameter().clear();
			getTypedParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__ASSOCIATION:
			getAssociation().clear();
			getAssociation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__SPECIFIED_END:
			getSpecifiedEnd().clear();
			getSpecifiedEnd().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			getPowertypeRange().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__INSTANCE:
			getInstance().clear();
			getInstance().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__CREATE_ACTION:
			getCreateAction().clear();
			getCreateAction().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			getObjectFlowState().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__RECEPTION:
			getReception().clear();
			getReception().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__CONTEXT:
			getContext().clear();
			getContext().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__SEND_ACTION:
			getSendAction().clear();
			getSendAction().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.SIGNAL__OCCURRENCE:
			getOccurrence().clear();
			getOccurrence().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.SIGNAL__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.SIGNAL__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.SIGNAL__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.SIGNAL__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.SIGNAL__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.SIGNAL__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.SIGNAL__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.SIGNAL__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.SIGNAL__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.SIGNAL__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.SIGNAL__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case Common_behaviorPackage.SIGNAL__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.SIGNAL__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.SIGNAL__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case Common_behaviorPackage.SIGNAL__STEREOTYPE:
			getStereotype().clear();
			return;
		case Common_behaviorPackage.SIGNAL__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.SIGNAL__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case Common_behaviorPackage.SIGNAL__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case Common_behaviorPackage.SIGNAL__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.SIGNAL__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.SIGNAL__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case Common_behaviorPackage.SIGNAL__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.SIGNAL__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.SIGNAL__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case Common_behaviorPackage.SIGNAL__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case Common_behaviorPackage.SIGNAL__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case Common_behaviorPackage.SIGNAL__GENERALIZATION:
			getGeneralization().clear();
			return;
		case Common_behaviorPackage.SIGNAL__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case Common_behaviorPackage.SIGNAL__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case Common_behaviorPackage.SIGNAL__FEATURE:
			getFeature().clear();
			return;
		case Common_behaviorPackage.SIGNAL__TYPED_FEATURE:
			getTypedFeature().clear();
			return;
		case Common_behaviorPackage.SIGNAL__TYPED_PARAMETER:
			getTypedParameter().clear();
			return;
		case Common_behaviorPackage.SIGNAL__ASSOCIATION:
			getAssociation().clear();
			return;
		case Common_behaviorPackage.SIGNAL__SPECIFIED_END:
			getSpecifiedEnd().clear();
			return;
		case Common_behaviorPackage.SIGNAL__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			return;
		case Common_behaviorPackage.SIGNAL__INSTANCE:
			getInstance().clear();
			return;
		case Common_behaviorPackage.SIGNAL__CREATE_ACTION:
			getCreateAction().clear();
			return;
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case Common_behaviorPackage.SIGNAL__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			return;
		case Common_behaviorPackage.SIGNAL__RECEPTION:
			getReception().clear();
			return;
		case Common_behaviorPackage.SIGNAL__CONTEXT:
			getContext().clear();
			return;
		case Common_behaviorPackage.SIGNAL__SEND_ACTION:
			getSendAction().clear();
			return;
		case Common_behaviorPackage.SIGNAL__OCCURRENCE:
			getOccurrence().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.SIGNAL__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.SIGNAL__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case Common_behaviorPackage.SIGNAL__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.SIGNAL__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.SIGNAL__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.SIGNAL__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.SIGNAL__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.SIGNAL__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.SIGNAL__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.SIGNAL__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.SIGNAL__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case Common_behaviorPackage.SIGNAL__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.SIGNAL__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.SIGNAL__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.SIGNAL__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case Common_behaviorPackage.SIGNAL__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case Common_behaviorPackage.SIGNAL__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.SIGNAL__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case Common_behaviorPackage.SIGNAL__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case Common_behaviorPackage.SIGNAL__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.SIGNAL__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.SIGNAL__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case Common_behaviorPackage.SIGNAL__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.SIGNAL__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.SIGNAL__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case Common_behaviorPackage.SIGNAL__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case Common_behaviorPackage.SIGNAL__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case Common_behaviorPackage.SIGNAL__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case Common_behaviorPackage.SIGNAL__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case Common_behaviorPackage.SIGNAL__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case Common_behaviorPackage.SIGNAL__FEATURE:
			return feature != null && !feature.isEmpty();
		case Common_behaviorPackage.SIGNAL__TYPED_FEATURE:
			return typedFeature != null && !typedFeature.isEmpty();
		case Common_behaviorPackage.SIGNAL__TYPED_PARAMETER:
			return typedParameter != null && !typedParameter.isEmpty();
		case Common_behaviorPackage.SIGNAL__ASSOCIATION:
			return association != null && !association.isEmpty();
		case Common_behaviorPackage.SIGNAL__SPECIFIED_END:
			return specifiedEnd != null && !specifiedEnd.isEmpty();
		case Common_behaviorPackage.SIGNAL__POWERTYPE_RANGE:
			return powertypeRange != null && !powertypeRange.isEmpty();
		case Common_behaviorPackage.SIGNAL__INSTANCE:
			return instance != null && !instance.isEmpty();
		case Common_behaviorPackage.SIGNAL__CREATE_ACTION:
			return createAction != null && !createAction.isEmpty();
		case Common_behaviorPackage.SIGNAL__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case Common_behaviorPackage.SIGNAL__OBJECT_FLOW_STATE:
			return objectFlowState != null && !objectFlowState.isEmpty();
		case Common_behaviorPackage.SIGNAL__RECEPTION:
			return reception != null && !reception.isEmpty();
		case Common_behaviorPackage.SIGNAL__CONTEXT:
			return context != null && !context.isEmpty();
		case Common_behaviorPackage.SIGNAL__SEND_ACTION:
			return sendAction != null && !sendAction.isEmpty();
		case Common_behaviorPackage.SIGNAL__OCCURRENCE:
			return occurrence != null && !occurrence.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // SignalImpl
