/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.editors.template.scanner;

import org.eclipse.jface.text.rules.RuleBasedScanner;

/**
 * Acceleo template based scanner.
 * 
 * @author www.obeo.fr
 * 
 */
public abstract class AcceleoTemplateBasedScanner extends RuleBasedScanner {

	/**
	 * Returns the type of the read tokens by this scanner.
	 * 
	 * @return the type of the read tokens
	 */
	public abstract String getConfiguredContentType();

}
