/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.foundation.core.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;

import fr.obeo.acceleo.uml14.foundation.core.Abstraction;
import fr.obeo.acceleo.uml14.foundation.core.Artifact;
import fr.obeo.acceleo.uml14.foundation.core.Association;
import fr.obeo.acceleo.uml14.foundation.core.AssociationClass;
import fr.obeo.acceleo.uml14.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml14.foundation.core.Attribute;
import fr.obeo.acceleo.uml14.foundation.core.Binding;
import fr.obeo.acceleo.uml14.foundation.core.Comment;
import fr.obeo.acceleo.uml14.foundation.core.Component;
import fr.obeo.acceleo.uml14.foundation.core.Constraint;
import fr.obeo.acceleo.uml14.foundation.core.CoreFactory;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.DataType;
import fr.obeo.acceleo.uml14.foundation.core.Dependency;
import fr.obeo.acceleo.uml14.foundation.core.ElementResidence;
import fr.obeo.acceleo.uml14.foundation.core.Enumeration;
import fr.obeo.acceleo.uml14.foundation.core.EnumerationLiteral;
import fr.obeo.acceleo.uml14.foundation.core.Flow;
import fr.obeo.acceleo.uml14.foundation.core.Generalization;
import fr.obeo.acceleo.uml14.foundation.core.Interface;
import fr.obeo.acceleo.uml14.foundation.core.Method;
import fr.obeo.acceleo.uml14.foundation.core.Node;
import fr.obeo.acceleo.uml14.foundation.core.Operation;
import fr.obeo.acceleo.uml14.foundation.core.Parameter;
import fr.obeo.acceleo.uml14.foundation.core.Permission;
import fr.obeo.acceleo.uml14.foundation.core.Primitive;
import fr.obeo.acceleo.uml14.foundation.core.ProgrammingLanguageDataType;
import fr.obeo.acceleo.uml14.foundation.core.Stereotype;
import fr.obeo.acceleo.uml14.foundation.core.TagDefinition;
import fr.obeo.acceleo.uml14.foundation.core.TaggedValue;
import fr.obeo.acceleo.uml14.foundation.core.TemplateArgument;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.Usage;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class CoreFactoryImpl extends EFactoryImpl implements CoreFactory {
	/**
	 * Creates an instance of the factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public CoreFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case CorePackage.CLASS:
			return createClass();
		case CorePackage.DATA_TYPE:
			return createDataType();
		case CorePackage.ASSOCIATION_END:
			return createAssociationEnd();
		case CorePackage.INTERFACE:
			return createInterface();
		case CorePackage.CONSTRAINT:
			return createConstraint();
		case CorePackage.ASSOCIATION:
			return createAssociation();
		case CorePackage.ATTRIBUTE:
			return createAttribute();
		case CorePackage.OPERATION:
			return createOperation();
		case CorePackage.PARAMETER:
			return createParameter();
		case CorePackage.METHOD:
			return createMethod();
		case CorePackage.GENERALIZATION:
			return createGeneralization();
		case CorePackage.ASSOCIATION_CLASS:
			return createAssociationClass();
		case CorePackage.DEPENDENCY:
			return createDependency();
		case CorePackage.ABSTRACTION:
			return createAbstraction();
		case CorePackage.USAGE:
			return createUsage();
		case CorePackage.BINDING:
			return createBinding();
		case CorePackage.COMPONENT:
			return createComponent();
		case CorePackage.NODE:
			return createNode();
		case CorePackage.PERMISSION:
			return createPermission();
		case CorePackage.COMMENT:
			return createComment();
		case CorePackage.FLOW:
			return createFlow();
		case CorePackage.ELEMENT_RESIDENCE:
			return createElementResidence();
		case CorePackage.TEMPLATE_PARAMETER:
			return createTemplateParameter();
		case CorePackage.PRIMITIVE:
			return createPrimitive();
		case CorePackage.ENUMERATION:
			return createEnumeration();
		case CorePackage.ENUMERATION_LITERAL:
			return createEnumerationLiteral();
		case CorePackage.STEREOTYPE:
			return createStereotype();
		case CorePackage.TAG_DEFINITION:
			return createTagDefinition();
		case CorePackage.TAGGED_VALUE:
			return createTaggedValue();
		case CorePackage.PROGRAMMING_LANGUAGE_DATA_TYPE:
			return createProgrammingLanguageDataType();
		case CorePackage.ARTIFACT:
			return createArtifact();
		case CorePackage.TEMPLATE_ARGUMENT:
			return createTemplateArgument();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public fr.obeo.acceleo.uml14.foundation.core.Class createClass() {
		ClassImpl class_ = new ClassImpl();
		return class_;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public DataType createDataType() {
		DataTypeImpl dataType = new DataTypeImpl();
		return dataType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationEnd createAssociationEnd() {
		AssociationEndImpl associationEnd = new AssociationEndImpl();
		return associationEnd;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Interface createInterface() {
		InterfaceImpl interface_ = new InterfaceImpl();
		return interface_;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Constraint createConstraint() {
		ConstraintImpl constraint = new ConstraintImpl();
		return constraint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Association createAssociation() {
		AssociationImpl association = new AssociationImpl();
		return association;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Attribute createAttribute() {
		AttributeImpl attribute = new AttributeImpl();
		return attribute;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Operation createOperation() {
		OperationImpl operation = new OperationImpl();
		return operation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Parameter createParameter() {
		ParameterImpl parameter = new ParameterImpl();
		return parameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Method createMethod() {
		MethodImpl method = new MethodImpl();
		return method;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Generalization createGeneralization() {
		GeneralizationImpl generalization = new GeneralizationImpl();
		return generalization;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationClass createAssociationClass() {
		AssociationClassImpl associationClass = new AssociationClassImpl();
		return associationClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Dependency createDependency() {
		DependencyImpl dependency = new DependencyImpl();
		return dependency;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Abstraction createAbstraction() {
		AbstractionImpl abstraction = new AbstractionImpl();
		return abstraction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Usage createUsage() {
		UsageImpl usage = new UsageImpl();
		return usage;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Binding createBinding() {
		BindingImpl binding = new BindingImpl();
		return binding;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Component createComponent() {
		ComponentImpl component = new ComponentImpl();
		return component;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Node createNode() {
		NodeImpl node = new NodeImpl();
		return node;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Permission createPermission() {
		PermissionImpl permission = new PermissionImpl();
		return permission;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Comment createComment() {
		CommentImpl comment = new CommentImpl();
		return comment;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Flow createFlow() {
		FlowImpl flow = new FlowImpl();
		return flow;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ElementResidence createElementResidence() {
		ElementResidenceImpl elementResidence = new ElementResidenceImpl();
		return elementResidence;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TemplateParameter createTemplateParameter() {
		TemplateParameterImpl templateParameter = new TemplateParameterImpl();
		return templateParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Primitive createPrimitive() {
		PrimitiveImpl primitive = new PrimitiveImpl();
		return primitive;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Enumeration createEnumeration() {
		EnumerationImpl enumeration = new EnumerationImpl();
		return enumeration;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EnumerationLiteral createEnumerationLiteral() {
		EnumerationLiteralImpl enumerationLiteral = new EnumerationLiteralImpl();
		return enumerationLiteral;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Stereotype createStereotype() {
		StereotypeImpl stereotype = new StereotypeImpl();
		return stereotype;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TagDefinition createTagDefinition() {
		TagDefinitionImpl tagDefinition = new TagDefinitionImpl();
		return tagDefinition;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TaggedValue createTaggedValue() {
		TaggedValueImpl taggedValue = new TaggedValueImpl();
		return taggedValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ProgrammingLanguageDataType createProgrammingLanguageDataType() {
		ProgrammingLanguageDataTypeImpl programmingLanguageDataType = new ProgrammingLanguageDataTypeImpl();
		return programmingLanguageDataType;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Artifact createArtifact() {
		ArtifactImpl artifact = new ArtifactImpl();
		return artifact;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TemplateArgument createTemplateArgument() {
		TemplateArgumentImpl templateArgument = new TemplateArgumentImpl();
		return templateArgument;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CorePackage getCorePackage() {
		return (CorePackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @deprecated
	 * @generated
	 */
	public static CorePackage getPackage() {
		return CorePackage.eINSTANCE;
	}

} // CoreFactoryImpl
